<?php
namespace Ep\Wp\Plugin;

use Zend\ServiceManager\AbstractFactory\ReflectionBasedAbstractFactory;
use Zend\ServiceManager\AbstractPluginManager;
use Zend\ServiceManager\Factory\InvokableFactory;

/**
 * Omogućava stvaranje WordPress pluginova iz konfiguracije.
 *
 * @package Ep\Wp\Plugin
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-wordpress
 */
class PluginManager extends AbstractPluginManager
{
    const CONFIG_KEY = 'wp_plugins';

    /** @var string */
    protected $instanceOf = PluginInterface::class;

    /** @var array */
    protected $aliases = [
        'assets'           => Assets::class,
        'Assets'           => Assets::class,
        'documentmeta'     => DocumentMeta::class,
        'documentMeta'     => DocumentMeta::class,
        'DocumentMeta'     => DocumentMeta::class,
        'translationcache' => TranslationCache::class,
        'translationCache' => TranslationCache::class,
        'TranslationCache' => TranslationCache::class,
        'views'            => Views::class,
        'Views'            => Views::class,
    ];

    /** @var array */
    protected $factories = [
        Assets::class           => ReflectionBasedAbstractFactory::class,
        DocumentMeta::class     => InvokableFactory::class,
        TranslationCache::class => TranslationCacheFactory::class,
        Views::class            => ReflectionBasedAbstractFactory::class,
    ];
}